Index: XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml	(revision 1669)
+++ XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_atmosphere.xml	(revision 1671)
@@ -3,15 +3,16 @@
 <context id="atmosphere">
 
-  <field_definition level="1" enabled=".FALSE." default_value="9.96921e+36">
-    <field id="field_A_atm"  name="field_A_atm_origin" operation="average" freq_op="1ts" grid_ref="grid_A_atm" />
-    <field id="field_A_atm_zoom"  name="field_A_atm" operation="average" freq_op="1ts" field_ref="field_A_atm" grid_ref="grid_A_atm_zoom" />
+  <field_definition level="1" enabled=".TRUE." default_value="9.96921e+36">
+    <field id="field_A_atm"  name="field_A_atm" operation="average" freq_op="1ts" grid_ref="grid_A_atm" />
+    <field id="field_A_atm_zoom"  operation="average" freq_op="1ts" field_ref="field_A_atm" grid_ref="grid_A_atm_zoom" />
   </field_definition>
 
-  <file_definition type="multiple_file" par_access="collective" output_freq="6h" sync_freq="6h" output_level="10" enabled=".TRUE.">
+  <file_definition type="one_file" par_access="collective" output_freq="6h" sync_freq="6h" output_level="10" enabled=".TRUE.">
     <file id="output_atmosphere" name="output_atmosphere">
-      <field field_ref="field_A_atm" />
+      <field field_ref="field_A_atm" build_workflow_graph=".TRUE."/>
+      <field field_ref="field_A_atm_zoom" name="field_A_atm_zoom" build_workflow_graph=".TRUE."/>
     </file>
     <file id="output_atmosphere_zoom" name="output_atmosphere_zoom">
-      <field field_ref="field_A_atm_zoom" name="field_A_atm_zoom" />
+      <field field_ref="field_A_atm_zoom" name="field_A_atm_zoom" build_workflow_graph=".FALSE."/>
     </file>
   </file_definition>
Index: XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_surface.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_surface.xml	(revision 1669)
+++ XIOS/dev/dev_trunk_omp/inputs/COMPLETE/context_surface.xml	(revision 1671)
@@ -12,7 +12,7 @@
   </field_definition>
 
-  <file_definition type="multiple_file" par_access="collective" output_level="10" enabled=".TRUE.">
+  <file_definition type="one_file" par_access="collective" output_level="10" enabled=".TRUE.">
     <file id="output_surface" name="output_surface_6h" output_freq="6h">
-      <field field_ref="field_A_srf">
+      <field field_ref="field_A_srf" build_workflow_graph=".FALSE."> 
         <variable id="my_attribute1" type="string">surf_att</variable>
         <variable id="my_attribute2" type="int"> 10 </variable>
@@ -20,18 +20,18 @@
         <variable id="my_attribute5" type="double">100.201</variable>
       </field>
-      <field field_ref="field_A_srf_K" build_workflow_graph=".TRUE." />
-      <field field_ref="field_A_srf_K_2" name="field_A_srf_K_2" /> <!-- Should be identical to field_A_srf_K -->
-      <field field_ref="field_A_srf_K" name="field_A_srf_K_3">field_A_srf_K</field> <!-- Should be identical to field_A_srf_K -->
-      <field field_ref="field_A_srf_K_2" name="field_A_srf_K_max_mean" long_name="Maximum of hourly average over 6h" operation="maximum" freq_op="1h"> @field_A_srf_K </field>
-      <field field_ref="field_A_srf" name="field_A_srf_min" operation="minimum" />
-      <field field_ref="field_A_srf_2" name="field_A_srf_min_2" operation="minimum" /> <!-- Should be identical to field_A_srf_min -->
-      <field field_ref="field_A_srf" name="field_A_srf_max" operation="maximum" />
-      <field field_ref="field_A_srf" name="field_A_srf_prec4" prec="8" />
-      <field field_ref="field_A_srf_max" name="field_A_srf_mean_max" long_name="Average of hourly maximum over 6h" operation="average" freq_op="1h"> @field_A_srf_max </field>
+      <field field_ref="field_A_srf_K" build_workflow_graph=".FALSE." />
+      <field field_ref="field_A_srf_K_2" name="field_A_srf_K_2" build_workflow_graph=".FALSE."/> <!-- Should be identical to field_A_srf_K -->
+      <field field_ref="field_A_srf_K" name="field_A_srf_K_3" build_workflow_graph=".FALSE.">field_A_srf_K</field> <!-- Should be identical to field_A_srf_K -->
+      <field field_ref="field_A_srf_K_2" name="field_A_srf_K_max_mean" build_workflow_graph=".FALSE." long_name="Maximum of hourly average over 6h" operation="maximum" freq_op="1h"> @field_A_srf_K </field>
+      <field field_ref="field_A_srf" name="field_A_srf_min" operation="minimum" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf_2" name="field_A_srf_min_2" operation="minimum" build_workflow_graph=".FALSE."/> <!-- Should be identical to field_A_srf_min -->
+      <field field_ref="field_A_srf" name="field_A_srf_max" operation="maximum" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf" name="field_A_srf_prec4" prec="8" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf_max" name="field_A_srf_mean_max" build_workflow_graph=".FALSE." long_name="Average of hourly maximum over 6h" operation="average" freq_op="1h"> @field_A_srf_max </field>
       <variable id="my_global_attribute" type="string">file_6h</variable>
     </file>
 
     <file type="one_file" id="output_surface_1d" name="output_surface_1d" output_freq="1d" enabled="TRUE">
-      <field field_ref="field_A_srf" indexed_output="TRUE">
+      <field field_ref="field_A_srf" indexed_output="TRUE" build_workflow_graph=".FALSE.">
         <variable id="my_attribute1" type="string">surf_att</variable>
         <variable id="my_attribute2" type="int">10</variable>
@@ -39,9 +39,9 @@
         <variable id="my_attribute4" type="double">100.201</variable>
       </field>
-      <field field_ref="field_A_srf_K" />
-      <field field_ref="field_A_srf" name="field_A_srf_min" operation="minimum" />
-      <field field_ref="field_A_srf" name="field_A_srf_max" operation="maximum" />
-      <field field_ref="field_A_srf" name="field_A_srf_prec4" prec="8" />
-      <field field_ref="field_A_srf_max" name="field_A_srf_mean_max" long_name="Average of hourly maximum over 1d" operation="average" freq_op="1h"> @field_A_srf_max </field>
+      <field field_ref="field_A_srf_K" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf" name="field_A_srf_min" operation="minimum" build_workflow_graph=".FALSE." />
+      <field field_ref="field_A_srf" name="field_A_srf_max" operation="maximum" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf" name="field_A_srf_prec4" prec="8" build_workflow_graph=".FALSE."/>
+      <field field_ref="field_A_srf_max" name="field_A_srf_mean_max"  build_workflow_graph=".FALSE." long_name="Average of hourly maximum over 1d" operation="average" freq_op="1h"> @field_A_srf_max </field>
       <variable id="my_global_attribute" type="string" >file_1d</variable>
     </file>
Index: XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1669)
+++ XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1671)
@@ -6,5 +6,5 @@
    <field_definition level="1" >
     <field_group id="fields_src" operation="instant">
-       <field id="src_field_2D"  domain_ref="src_domain"/>
+       <field id="src_field_2D" domain_ref="src_domain"/>
        <field id="src_field_2D_clone" domain_ref="src_domain_clone"/>
        <field id="src_field_3D" domain_ref="src_domain" axis_ref="src_axis"/>       
@@ -35,5 +35,5 @@
         <file id="output_2D" name="output_2D" >
           <field field_ref="src_field_2D" name="field_src" build_workflow_graph=".TRUE."/>
-          <field field_ref="src_field_2D" name="field_dst_regular_0"  domain_ref="dst_domain_regular_pole" default_value="10.e+5" build_workflow_graph=".TRUE."/>
+          <field field_ref="src_field_2D" name="field_dst_regular_0" build_workflow_graph=".TRUE." domain_ref="dst_domain_regular_pole" default_value="10.e+5"/>
           <field field_ref="dst_field_2D" name="field_dst_regular_1" build_workflow_graph=".TRUE."/>
           <field field_ref="dst_field_2D_regular_pole" name="field_dst_regular_2" build_workflow_graph=".TRUE."/>
Index: XIOS/dev/dev_trunk_omp/inputs/iodef.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1669)
+++ XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1671)
@@ -19,13 +19,13 @@
         <!-- <field field_ref="field_Domain" name="field_A" /> -->
         <field field_ref="field_A" name="field_A" build_workflow_graph=".TRUE." /> 
-        <field field_ref="field_A_zoom" name="field_B" />
+        <field field_ref="field_A_zoom" name="field_B" build_workflow_graph=".TRUE."/>
      </file>
      <file id="output1" name="output1" enabled=".TRUE.">
         <!-- <field field_ref="field_Domain" name="field_A" /> -->
-        <field field_ref="field_A" name="field_A" />        
+        <field field_ref="field_A" name="field_A_dup" build_workflow_graph=".TRUE."/>        
      </file>  
-     <file id="output2" name="output2" enabled=".FALSE.">
+     <file id="output2" name="output2" enabled=".TRUE.">
         <!-- <field field_ref="field_Domain" name="field_A" /> -->
-        <field field_ref="field_Scalar" name="field_A" />        
+        <field field_ref="field_Scalar" name="field_A_scalar" build_workflow_graph=".TRUE."/>        
      </file>
  <!--     <file id="output_s" name="output_s" mode="read" >