Index: XIOS/dev/dev_trunk_omp/inputs/iodef.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1680)
+++ XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1681)
@@ -7,7 +7,7 @@
 
    <field_definition level="1" enabled=".TRUE.">
-     <field id="field_A"  operation="average" freq_op="3600s" grid_ref="grid_A" build_workflow_graph=".FALSE."/>
+     <field id="field_A"  operation="average" freq_op="3600s" grid_ref="grid_A" />
      <field id="field_B"  operation="average" freq_op="3600s" grid_ref="grid_A"/>
-     <field id="field_C"  operation="average" freq_op="3600s" grid_ref="grid_A"/>
+     <field id="field_C"  operation="average" freq_op="3600s" grid_ref="grid_A" />
      <field id="field_Axis"  operation="average" freq_op="3600s" axis_ref="axis_A"/>
      <field id="field_Domain"  operation="average" freq_op="3600s" domain_ref="domain_A"/>
@@ -18,22 +18,28 @@
 
    <file_definition type="one_file" par_access="collective" output_freq="1h" output_level="10" >
-      <file id="output" name="output" enabled=".TRUE.">
+      
+     <file id="output2" name="output2" output_freq="4h" enabled=".FALSE.">
+        <field id="field_G" field_ref="field_A" name="field_G_zoom" grid_ref="grid_A_zoom" build_workflow_graph=".TRUE." build_workflow_graph_start="1h" build_workflow_graph_end="8h" />        
+        <!-- <field field_ref="field_Scalar" name="field_A_scalar" build_workflow_graph=".TRUE."/>         -->
+     </file>
+
+
+     <file id="output1" name="output1" output_freq="24h" enabled=".TRUE.">
         <!-- <field field_ref="field_Domain" name="field_A" /> -->
-        <field field_ref="field_A" name="field_A_name"  build_workflow_graph=".TRUE." /> 
-        <field field_ref="field_B" name="field_B_name"  build_workflow_graph=".TRUE."/> 
-        <!-- <field field_ref="field_C" name="field_C_name" enabled=".TRUE." />  -->
-        <field id="field_D" field_ref="field_A" operation="instant" build_workflow_graph=".TRUE." name="field_D_name" build_workflow_graph_start="1h" > sqrt(field_A) + sqrt(field_B) + sqrt(field_C) </field>
-        <field id="field_E" field_ref="field_A" operation="instant" build_workflow_graph=".TRUE." name="field_E_name" build_workflow_graph_start="1h" > sqrt(field_A) + sqrt(field_B) + sqrt(field_C)</field>
+        <field id="field_F" field_ref="field_A" name="field_24h" grid_ref="grid_A" build_workflow_graph=".TRUE." build_workflow_graph_start="4h" build_workflow_graph_end="24h"  />        
+        
+     </file>  
+
+     <file id="output" name="output" enabled=".TRUE.">
+        <!-- <field field_ref="field_Domain" name="field_A" /> -->
+        <!-- <field field_ref="field_A" name="field_A_name"  build_workflow_graph=".FALSE." />  -->
+        <!-- <field field_ref="field_B" name="field_B_name"  build_workflow_graph=".FALSE."/>  -->
+        <!-- <field field_ref="field_C" name="field_C_name"  enabled=".TRUE." />  -->
+        <!-- <field id="field_D" field_ref="field_A" operation="instant" build_workflow_graph=".TRUE." name="field_D_name" build_workflow_graph_start="1h" build_workflow_graph_end="2h" > sqrt(field_A) </field> -->
+        <field id="field_E" field_ref="field_A" operation="instant" build_workflow_graph=".TRUE." name="field_E_name" build_workflow_graph_start="1h" build_workflow_graph_end="4h" > field_A + field_B + field_C</field>
         <!-- <field field_ref="field_A_zoom" name="field_B" build_workflow_graph=".TRUE."/> -->
      </file>
-     <file id="output1" name="output1" output_freq="8h" enabled=".TRUE.">
-        <!-- <field field_ref="field_Domain" name="field_A" /> -->
-        <field id="field_F" field_ref="field_A" name="field_A_zoom" grid_ref="grid_A_zoom" build_workflow_graph=".TRUE."   />        
-        
-     </file>  
-     <file id="output2" name="output2" output_freq="4h" enabled=".TRUE.">
-        <field id="field_G" field_ref="field_A" name="field_G_zoom" grid_ref="grid_A_zoom" build_workflow_graph=".TRUE." build_workflow_graph_start="1h" build_workflow_graph_end="4h" />        
-        <!-- <field field_ref="field_Scalar" name="field_A_scalar" build_workflow_graph=".TRUE."/>         -->
-     </file>
+
+     
  <!--     <file id="output_s" name="output_s" mode="read" >
        <field id="field" name="field_A" grid_ref="grid_Scalar" operation="instant" />