Index: XIOS/dev/dev_trunk_omp/inputs/vis.html
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/vis.html	(revision 1682)
+++ XIOS/dev/dev_trunk_omp/inputs/vis.html	(revision 1683)
@@ -113,9 +113,28 @@
 
             //===========================================================
+            $('#clusteringcid2').on('click', function() 
+            {
+                network.setData(data);
+                var clusterOptionsByData = 
+                {
+                    joinCondition:function(childOptions) 
+                    {
+                        return childOptions.cid === 2;
+                    },
+                    clusterNodeProperties: {id:'cidCluster', borderWidth:3, shape:'database'}
+                };
+                network.clustering.cluster(clusterOptionsByData);
+                var allNode = nodes.get();
+                nodes.update(allNode);
+            });
+
+
+
+            //===========================================================
             $('#lastTemporal').on('click', function() 
             {
                 var node = nodes.get(nodeSelected);
 
-                if(node.class == '5') //temporal filter
+                if(node.class == 5) //temporal filter
                 {
                     var inputnodes = network.getConnectedNodes(node.id, 'from');
@@ -142,5 +161,5 @@
                     edges.update(edges_ofinputnode);
 
-                    allNode = nodes.get();
+                    var allNode = nodes.get();
                     nodes.update(allNode);
 
@@ -211,5 +230,5 @@
                     var node = allNode[i];
 
-                    if(node.class == '1')
+                    if(node.class == 1)
                     {
                         node.hidden = false; 
@@ -230,5 +249,5 @@
                     var node = allNode[i];
 
-                    if(node.class >= '6' || node.filled==1)
+                    if(node.class >= 6 || node.filled==1)
                     {
                         node.hidden = false;
@@ -724,4 +743,5 @@
                 }
 
+
                 var reader = new FileReader();
                 var json;
@@ -749,37 +769,19 @@
                                 var nboutVal = node.nbout;
 
-                                // if (node.class == '6' || node.filled == 1 )
-                                if (true)
-                                {
-                                    node.color = {
+                                node.color = {
+                                    background: styleArr[classVal].background,
+                                    border: styleArr[classVal].border,
+                                    hover: styleArr[classVal].background,
+                                    highlight: {
                                         background: styleArr[classVal].background,
-                                        border: styleArr[classVal].border,
-                                        hover: styleArr[classVal].background,
-                                        highlight: {
-                                            background: styleArr[classVal].background,
-                                            border: 'blue'
-                                        }
+                                        border: 'blue'
                                     }
                                 }
-                                else
-                                {    
-                                    node.color = {
-                                        background: 'white',
-                                        border: 'LightGray',
-                                        hover: 'LightGray',
-                                        highlight: {
-                                            background: 'LightGray',
-                                            border: 'blue'
-                                        }
-                                    }
-                                    node.font = {
-                                        color:'white'
-                                    }
-                                }
+                                
                                 node.shape = styleArr[classVal].shape;
 
-                                if (node.class == '1' || node.class >= '6')
+                                if (node.class == 1 || node.class >= 6)
                                     node.title = "node id = "+node.id+"</br>"+labelVal +"</br>field attributes : </br>" + attrVal + "</br>filter entry nb = " + entryVal + "</br>cid = " + cidVal + "</br>distance = " + distVal ;
-                                else if (node.class == '5')
+                                else if (node.class == 5)
                                     node.title = "node id = "+node.id+"</br>"+labelVal +"</br>filter type = " + typeVal + "</br> entry nb = " + entryVal + "</br> inputs_complete = " + inputsVal + "</br>cid = " + cidVal + "</br>distance = " + distVal ;
                                 else
@@ -802,5 +804,5 @@
                                 node.level = distVal;
 
-                                if (node.class == '6' || node.filled == 1) node.hidden = true;
+                                if (node.class >= 6 || node.filled == 1) node.hidden = true;
                                 else node.hidden = true;
 
@@ -868,4 +870,10 @@
                                     }
                                 },
+
+                                joinCondition:function(nodeOptions) {
+                                    return nodeOptions.cid === 2;
+  
+                                }
+
                                 
                             };
@@ -873,4 +881,6 @@
                             //==================================================
                             network = new vis.Network(container, data, options);
+
+
 
                             //==================================================
@@ -1000,4 +1010,7 @@
             <button type="button" class="btn btn-default" id="disableAllChild">Disable all children</button>
             <button type="button" class="btn btn-default" id="lastTemporal">Enable last temporal input</button>
+
+
+            <button type="button" class="btn btn-default" id="clusteringcid2">Clustering cid=2</button>
         </div>
 
Index: XIOS/dev/dev_trunk_omp/src/graphviz.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/graphviz.cpp	(revision 1682)
+++ XIOS/dev/dev_trunk_omp/src/graphviz.cpp	(revision 1683)
@@ -97,12 +97,12 @@
         else
           fs_json << "       \"label\": \""<<it->second.filter_name<<"\", "<<std::endl;
-        fs_json << "       \"class\": \""<<it->second.filter_class<<"\", "<<std::endl;
-        fs_json << "       \"filled\": \""<<it->second.filter_filled<<"\", "<<std::endl;
+        fs_json << "       \"class\": "<<it->second.filter_class<<", "<<std::endl;
+        fs_json << "       \"filled\": "<<it->second.filter_filled<<", "<<std::endl;
         fs_json << "       \"type\": \""<<it->second.transform_type<<"\", "<<std::endl;
-        fs_json << "       \"entry\": \""<<it->second.expected_entry_nb<<"\", "<<std::endl;
-        fs_json << "       \"inputs\": \""<<it->second.inputs_complete<<"\", "<<std::endl;
-        fs_json << "       \"tag\": \""<<it->second.filter_tag<<"\", "<<std::endl;
-        fs_json << "       \"cid\": \""<<it->second.clusterID<<"\", "<<std::endl;
-        fs_json << "       \"distance\": \""<<it->second.distance<<"\", "<<std::endl;
+        fs_json << "       \"entry\": "<<it->second.expected_entry_nb<<", "<<std::endl;
+        fs_json << "       \"inputs\": "<<it->second.inputs_complete<<", "<<std::endl;
+        fs_json << "       \"tag\": "<<it->second.filter_tag<<", "<<std::endl;
+        fs_json << "       \"cid\": "<<it->second.clusterID<<", "<<std::endl;
+        fs_json << "       \"distance\": "<<it->second.distance<<", "<<std::endl;
         fs_json << "       \"attributes\": \""<<it->second.attributes<<"\"}"<<std::endl<<"      ";
       }