Index: XIOS/dev/dev_trunk_graph/src/filter/file_writer_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/filter/file_writer_filter.cpp	(revision 1687)
+++ XIOS/dev/dev_trunk_graph/src/filter/file_writer_filter.cpp	(revision 1688)
@@ -36,5 +36,5 @@
       (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
       (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].clusterID =1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = ++(data[0]->distance);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
 
       if(CXios::isClient && CWorkflowGraph::build_begin) 
Index: XIOS/dev/dev_trunk_graph/src/filter/pass_through_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/filter/pass_through_filter.cpp	(revision 1687)
+++ XIOS/dev/dev_trunk_graph/src/filter/pass_through_filter.cpp	(revision 1688)
@@ -25,5 +25,5 @@
 
       CWorkflowGraph::addNode(this->filterID, "Pass Through Filter\\n("+data[0]->field->getId()+")", 2, 1, 1, data[0]);
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = ++(data[0]->distance);
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
 
       (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
@@ -39,4 +39,5 @@
       
       data[0]->src_filterID=this->filterID;
+      data[0]->distance++;
 
     }
Index: XIOS/dev/dev_trunk_graph/src/filter/source_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/filter/source_filter.cpp	(revision 1687)
+++ XIOS/dev/dev_trunk_graph/src/filter/source_filter.cpp	(revision 1688)
@@ -28,5 +28,4 @@
   {
     bool building_graph = this->tag ? packet->timestamp >= this->field->field_graph_start && packet->timestamp <= this->field->field_graph_end : false;
-   
     if(building_graph)
     {
Index: XIOS/dev/dev_trunk_graph/src/filter/spatial_transform_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/filter/spatial_transform_filter.cpp	(revision 1687)
+++ XIOS/dev/dev_trunk_graph/src/filter/spatial_transform_filter.cpp	(revision 1688)
@@ -215,4 +215,8 @@
     }
 
+    if(BG) packet->src_filterID=this->filterID;
+    if(BG) packet->distance=data[0]->distance+1;
+    packet->field = field;
+
     return packet;
   }
Index: XIOS/dev/dev_trunk_graph/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/field.cpp	(revision 1687)
+++ XIOS/dev/dev_trunk_graph/src/node/field.cpp	(revision 1688)
@@ -1117,6 +1117,6 @@
    TRY
    {     
-    if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
-    if (!isGridChecked) checkGridOfEnabledFields();
+     if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
+     if (!isGridChecked) checkGridOfEnabledFields();
 
      const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
@@ -1234,5 +1234,5 @@
              if (grid && grid != gridRef && grid->hasTransform())
              {
-                 std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue); 
+               std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue);
 
                filter->connectOutput(filters.first, 0);
@@ -1517,18 +1517,4 @@
      CContext* context = CContext::getCurrent();
 
-     // Time filter_start;
-     // if(!build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = context->calendar->getInitDate()+build_workflow_graph_start;
-     // else if(build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = 0;
-     // else filter_start = -1;
-
-     // Time filter_end;
-     // if(!build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = context->calendar->getInitDate()+build_workflow_graph_end;
-     // else if(build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = 9223372036854775807;
-     // else filter_end = -1;
-
-     // filter_start = this->field_graph_start;
-     // filter_end = this->field_graph_end;
-
-     // if(CXios::isClient) std::cout<<"getTemporalDataFilter field_id = "<<this->getId()<<" this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
 
      if (it == temporalDataFilters.end())
@@ -1594,6 +1580,6 @@
        bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
        std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
-                                                                             CContext::getCurrent()->getCalendar()->getInitDate(),
-                                                                             freq_op, freq_offset, outFreq, detectMissingValues));
+                                                                           CContext::getCurrent()->getCalendar()->getInitDate(),
+                                                                           freq_op, freq_offset, outFreq, detectMissingValues));
 
        selfReferenceFilter->connectOutput(temporalFilter, 0);