Index: XIOS/dev/dev_trunk_omp/inputs/vis2.html
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/vis2.html	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/inputs/vis2.html	(revision 1689)
@@ -23,12 +23,12 @@
 
         #mynetwork {
-            width: 600px;
-            height: 600px;
+            width: 1000px;
+            height: 1000px;
             border: 1px solid lightgray;
         }
 
         #mynetwork1 {
-            width: 600px;
-            height: 600px;
+            width: 200px;
+            height: 200px;
             border: 1px solid lightgray;
         }
@@ -217,9 +217,20 @@
                 nodes.update(allNode);
 
+                node = nodes.get(nodeSelected);
+                connectedEdgeArray = edges.get(network.getConnectedEdges(node.id));
+                for (j = 0; j < connectedEdgeArray.length; j++) {
+                    var edge = connectedEdgeArray[j];
+                    if (edge.from == node.id) {
+                        edge.hidden = false;
+                    }
+
+                }
+                edges.update(connectedEdgeArray);
+
                 allNode = nodes.get();
                 nodes.update(allNode);
 
 
-                // network1 = new vis.Network(container1, data);
+                network1 = new vis.Network(container1, data);
 
 
@@ -895,9 +906,4 @@
                                 },
 
-                                joinCondition: function(nodeOptions) {
-                                    return nodeOptions.cid === 2;
-
-                                }
-
 
                             };
@@ -905,5 +911,5 @@
                             //==================================================
                             network = new vis.Network(container, data, options);
-                            network1 = new vis.Network(container1, data, options);
+                            //network1 = new vis.Network(container1, data, options);
                             
 
Index: XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1689)
@@ -77,5 +77,4 @@
   CDataPacketPtr CScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-    
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -166,5 +165,4 @@
   CDataPacketPtr CFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -271,5 +269,4 @@
   CDataPacketPtr CFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
Index: XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.cpp	(revision 1689)
@@ -28,5 +28,3 @@
     return true;
   }
-
-
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/file_server_writer_filter.hpp	(revision 1689)
@@ -37,5 +37,4 @@
       bool virtual isDataExpected(const CDate& date) const;
 
-
     protected:
       /*!
@@ -49,5 +48,4 @@
       CField* field; //<! The associated field
       std::map<Time, CDataPacketPtr> packets; //<! The stored packets
-
   }; // class CFileServerWriterFilter
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp	(revision 1689)
@@ -73,7 +73,4 @@
 
     field->sendUpdateData(dataArray);
-    
-    
-    
   }
 
@@ -87,6 +84,3 @@
     return true;
   }
-
-
-
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.hpp	(revision 1689)
@@ -48,6 +48,4 @@
        */
       bool virtual isDataExpected(const CDate& date) const;
-      
-
 
     protected:
@@ -62,5 +60,4 @@
     private:
       std::map<Time, CDataPacketPtr> packets; //<! The stored packets
-
   }; // class CFileWriterFilter
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/filter.cpp	(revision 1689)
@@ -16,7 +16,5 @@
     CDataPacketPtr outputPacket = engine->apply(data);
     if (outputPacket)
-    {
       onOutputReady(outputPacket);
-    } 
   }
 
@@ -54,5 +52,3 @@
     return COutputPin::isDataExpected(date);
   }
-
-  
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/input_pin.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/input_pin.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/input_pin.cpp	(revision 1689)
@@ -83,8 +83,3 @@
     inputs.erase(inputs.begin(), inputs.lower_bound(timestamp));
   }
-
-
-  
-
-
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/input_pin.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/input_pin.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/input_pin.hpp	(revision 1689)
@@ -18,5 +18,4 @@
   {
     public:
-
       /*!
        * Constructs an input pin with the specified number of slots
@@ -82,5 +81,4 @@
        */
       void virtual invalidate(Time timestamp);
-      
 
     protected:
Index: XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp	(revision 1689)
@@ -5,6 +5,4 @@
 namespace xios
 {
-
-
   COutputPin::COutputPin(CGarbageCollector& gc, bool manualTrigger /*= false*/)
     : gc(gc)
@@ -34,5 +32,4 @@
       ERROR("void COutputPin::onOutputReady(CDataPacketPtr packet)",
             "The packet cannot be null.");
-  
 
     if (manualTrigger) // Don't use canBeTriggered here, this function is virtual and can be overriden
Index: XIOS/dev/dev_trunk_omp/src/filter/output_pin.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/output_pin.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/output_pin.hpp	(revision 1689)
@@ -34,5 +34,4 @@
        * \param gc the garbage collector associated with this ouput pin
        * \param slotsCount the number of slots
-       * \param buildWorkflowGraph indicates whether data will be visualized
        */
       COutputPin(CGarbageCollector& gc, bool manualTrigger = false);
@@ -118,5 +117,4 @@
       //! Output buffer, store the packets until the output is triggered
       std::map<Time, CDataPacketPtr> outputPackets;
-
   }; // class COutputPin
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp	(revision 1689)
@@ -18,5 +18,4 @@
     if(building_graph)
     {
-      std::cout<<"pass through packet->distance = "<<data[0]->distance<<std::endl;
       // std::cout<<"CPassThroughFilter::apply field_id = "<<this->field->getId()<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
       this->filterID = InvalidableObject::filterIdGenerator++;
@@ -45,5 +44,4 @@
 
     data[0]->field = this->field;
-
   }
 
@@ -53,4 +51,3 @@
     return data[0];
   }
-
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/source_filter.cpp	(revision 1689)
@@ -28,9 +28,4 @@
   {
     bool building_graph = this->tag ? packet->timestamp >= this->field->field_graph_start && packet->timestamp <= this->field->field_graph_end : false;
-    // bool building_graph = this->tag ? packet->timestamp >= this->start_graph && packet->timestamp <= this->end_graph : false;
-    
-    // std::cout<<"************************************************source filter 1 : field_id = "<<this->field->getId()<<" this->start_graph = "<<this->start_graph<<" this->end_graph = "<<this->end_graph<<std::endl;
-    // std::cout<<"************************************************source filter 2 : field_id = "<<this->field->getId()<<" this->field->field_graph_start = "<<this->field->field_graph_start<<" this->field->field_graph_end = "<<this->field->field_graph_end<<std::endl;
-
     if(building_graph)
     {
@@ -40,5 +35,4 @@
       packet->distance = 1;
       
-      // if(CXios::isClient) std::cout<<"source filter tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
     
       CWorkflowGraph::allocNodeEdge();
@@ -52,5 +46,4 @@
     }
 
-    // if(building_graph) std::cout<<packet->timestamp<<"************************************************ source filter : field_id = "<<this->field->getId()<<" start = "<<this->field->field_graph_start<<" end_graph = "<<this->field->field_graph_end<<std::endl;
   }
 
@@ -107,6 +100,4 @@
   template void CSourceFilter::streamData<7>(CDate date, const CArray<double, 7>& data);
 
-
-
   void CSourceFilter::streamDataFromServer(CDate date, const std::map<int, CArray<double, 1> >& data)
   {
@@ -157,5 +148,3 @@
     onOutputReady(packet);
   }
-
-  
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/source_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/source_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/source_filter.hpp	(revision 1689)
@@ -75,5 +75,4 @@
       const bool compression ; //!< indicates if data need to be compressed : on client side : true, on server side : false
       const bool mask ;        //!< indicates whether grid mask should be applied (true for clients, false for servers)
-
   }; // class CSourceFilter
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.cpp	(revision 1689)
@@ -12,6 +12,5 @@
 namespace xios
 {
-  CSpatialTransformFilter::CSpatialTransformFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine,
-                                                   double outputValue, size_t inputSlotsCount)
+  CSpatialTransformFilter::CSpatialTransformFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, double outputValue, size_t inputSlotsCount)
     : CFilter(gc, inputSlotsCount, engine), outputDefaultValue(outputValue)
   { /* Nothing to do */ }
@@ -43,8 +42,6 @@
 
       std::shared_ptr<CSpatialTransformFilter> filter ;
-      if( isSpatialTemporal)
-        filter = std::shared_ptr<CSpatialTransformFilter>(new CSpatialTemporalFilter(gc, engine, gridTransformation, defaultValue, inputCount));
-      else
-        filter = std::shared_ptr<CSpatialTransformFilter>(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
+      if( isSpatialTemporal) filter = std::shared_ptr<CSpatialTransformFilter>(new CSpatialTemporalFilter(gc, engine, gridTransformation, defaultValue, inputCount));
+      else filter = std::shared_ptr<CSpatialTransformFilter>(new CSpatialTransformFilter(gc, engine, defaultValue, inputCount));
 
       
@@ -52,7 +49,5 @@
         lastFilter = filter;
       else
-      {
         filter->connectOutput(firstFilter, 0);
-      }
 
       firstFilter = filter;
@@ -73,16 +68,11 @@
   void CSpatialTransformFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
-
     CSpatialTransformFilterEngine* spaceFilter = static_cast<CSpatialTransformFilterEngine*>(engine);
     CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue, this->tag, this->start_graph, this->end_graph, this->field);
     if (outputPacket)
-    {
       onOutputReady(outputPacket);
-    } 
-  }
-
-  CSpatialTemporalFilter::CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine,
-                                                  CGridTransformation* gridTransformation, double outputValue,
-                                                  size_t inputSlotsCount)
+  }
+
+  CSpatialTemporalFilter::CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation, double outputValue, size_t inputSlotsCount)
     : CSpatialTransformFilter(gc, engine, outputValue, inputSlotsCount), record(0)
   {
@@ -110,5 +100,4 @@
   void CSpatialTemporalFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
-
     CSpatialTransformFilterEngine* spaceFilter = static_cast<CSpatialTransformFilterEngine*>(engine);
     CDataPacketPtr outputPacket = spaceFilter->applyFilter(data, outputDefaultValue, this->tag, this->start_graph, this->end_graph, this->field);
@@ -160,7 +149,5 @@
       ERROR("CSpatialTransformFilterEngine& CSpatialTransformFilterEngine::get(CGridTransformation* gridTransformation)",
             "Impossible to get the requested engine, the grid transformation is invalid.");
-    
     if(engines_ptr == NULL) engines_ptr = new std::map<CGridTransformation*, std::shared_ptr<CSpatialTransformFilterEngine> >;
-
 
     std::map<CGridTransformation*, std::shared_ptr<CSpatialTransformFilterEngine> >::iterator it = engines_ptr->find(gridTransformation);
@@ -216,5 +203,4 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
-    
 
     if (packet->status == CDataPacket::NO_ERROR)
Index: XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/spatial_transform_filter.hpp	(revision 1689)
@@ -73,8 +73,6 @@
        * \param outputValue default value of output pin
        * \param [in] inputSlotsCount number of input, by default there is only one for field src
-       *
        */
-      CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation,
-                            double outputValue, size_t inputSlotsCount = 1);
+      CSpatialTemporalFilter(CGarbageCollector& gc, CSpatialTransformFilterEngine* engine, CGridTransformation* gridTransformation, double outputValue, size_t inputSlotsCount = 1);
 
 
Index: XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/store_filter.cpp	(revision 1689)
@@ -167,5 +167,3 @@
     packets.erase(packets.begin(), packets.lower_bound(timestamp));
   }
-
-
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/store_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/store_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/store_filter.hpp	(revision 1689)
@@ -100,6 +100,4 @@
       const double missingValue; //!< The value to use to replace missing values
       std::map<Time, CDataPacketPtr> packets; //<! The stored packets
-
-
   }; // class CStoreFilter
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.cpp	(revision 1689)
@@ -126,5 +126,4 @@
           packet->data.resize(tmpData.numElements());
           packet->data = tmpData;
-          
         }
         else
@@ -139,5 +138,4 @@
           packet->src_filterID=this->filterID;
           packet->distance = data[0]->distance+1;
-          std::cout<<"temporal packet->distance = "<<packet->distance<<std::endl;
           this->filterIDoutputs.clear();
           CWorkflowGraph::build_begin=true;
Index: XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/temporal_filter.hpp	(revision 1689)
@@ -77,5 +77,4 @@
 //      CDate nextOperationDate; //!< The date of the next operation
       bool isFirstOperation; //!< True before the first operation was been computed
-
   }; // class CTemporalFilter
 } // namespace xios
Index: XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/ternary_arithmetic_filter.cpp	(revision 1689)
@@ -76,5 +76,4 @@
   CDataPacketPtr CScalarScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-  
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -166,5 +165,4 @@
   CDataPacketPtr CScalarFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -270,5 +268,4 @@
   CDataPacketPtr CScalarFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -368,5 +365,4 @@
   CDataPacketPtr CFieldScalarScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -473,5 +469,4 @@
   CDataPacketPtr CFieldScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -584,5 +579,4 @@
   CDataPacketPtr CFieldFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -707,5 +701,4 @@
   CDataPacketPtr CFieldFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
Index: XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/filter/unary_arithmetic_filter.cpp	(revision 1689)
@@ -71,5 +71,4 @@
   CDataPacketPtr CUnaryArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
   {
-
     CDataPacketPtr packet(new CDataPacket);
     packet->date = data[0]->date;
@@ -91,3 +90,2 @@
   }
 } // namespace xios
-
Index: XIOS/dev/dev_trunk_omp/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1685)
+++ XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1689)
@@ -77,7 +77,4 @@
 
   //----------------------------------------------------------------
-
-
-   
 
    void CField::setVirtualVariableGroup(CVariableGroup* newVVariableGroup)
@@ -688,5 +685,5 @@
 
    //----------------------------------------------------------------
-   
+
    StdString CField::GetName(void)    { return StdString("field"); }
    StdString CField::GetDefName(void) { return CField::GetName(); }
@@ -920,5 +917,4 @@
    TRY
    {
-
      CContext* context = CContext::getCurrent();
      bool hasClient = context->hasClient;
@@ -1223,5 +1219,5 @@
          {
            fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this));
-           instantDataFilter->connectOutput(fileWriterFilter, 0);        
+           instantDataFilter->connectOutput(fileWriterFilter, 0);
          }
        }
@@ -1241,17 +1237,12 @@
            if (!field_ref.isEmpty())
            {
-             CField* fieldRef = CField::get(field_ref);
-             CGrid* gridRef = fieldRef->grid;
+             CGrid* gridRef = CField::get(field_ref)->grid;
 
              if (grid && grid != gridRef && grid->hasTransform())
              {
-               std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid,
-                                                                                         detectMissingValues, defaultValue);
+               std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = CSpatialTransformFilter::buildFilterGraph(gc, gridRef, grid, detectMissingValues, defaultValue);
 
                filter->connectOutput(filters.first, 0);
-
-
                filter = filters.second;
-               
              }
            }
@@ -1354,7 +1345,4 @@
    TRY
    {
-
-      
-
      if (instantDataFilter || field_ref.isEmpty())
        ERROR("COutputPin* CField::getFieldReference(CGarbageCollector& gc)",
@@ -1510,5 +1498,5 @@
 
          selfReferenceFilter = clientSourceFilter;
-       }    
+       }
      }
 
@@ -1536,18 +1524,4 @@
      CContext* context = CContext::getCurrent();
 
-     // Time filter_start;
-     // if(!build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = context->calendar->getInitDate()+build_workflow_graph_start;
-     // else if(build_workflow_graph_start.isEmpty() && buildWorkflowGraph) filter_start = 0;
-     // else filter_start = -1;
-
-     // Time filter_end;
-     // if(!build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = context->calendar->getInitDate()+build_workflow_graph_end;
-     // else if(build_workflow_graph_end.isEmpty() && buildWorkflowGraph) filter_end = 9223372036854775807;
-     // else filter_end = -1;
-
-     // filter_start = this->field_graph_start;
-     // filter_end = this->field_graph_end;
-
-     // if(CXios::isClient) std::cout<<"getTemporalDataFilter field_id = "<<this->getId()<<" this->field_graph_start = "<<this->field_graph_start<<" this->field_graph_end = "<<this->field_graph_end<<std::endl;
 
      if (it == temporalDataFilters.end())
@@ -1614,6 +1588,5 @@
        std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
                                                                            CContext::getCurrent()->getCalendar()->getInitDate(),
-                                                                           freq_op, freq_offset, outFreq,
-                                                                           detectMissingValues));
+                                                                           freq_op, freq_offset, outFreq, detectMissingValues));
 
        selfReferenceFilter->connectOutput(temporalFilter, 0);