Index: XIOS/dev/dev_trunk_omp/inputs/iodef.xml
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1689)
+++ XIOS/dev/dev_trunk_omp/inputs/iodef.xml	(revision 1691)
@@ -17,5 +17,5 @@
 
 
-   <file_definition type="one_file" par_access="collective" output_freq="1h" output_level="10" >
+    <file_definition type="multiple_file" par_access="collective" output_freq="1h" output_level="10" > 
       
      <file id="output2" name="output2" output_freq="4h" enabled=".FALSE.">
@@ -25,5 +25,5 @@
 
 
-     <file id="output1" name="output1" output_freq="24h" enabled=".TRUE.">
+     <file id="output1" name="output1" output_freq="24h" enabled=".FALSE.">
         <!-- <field field_ref="field_Domain" name="field_A" /> -->
         <field id="field_F" field_ref="field_A" name="field_24h" grid_ref="grid_A" build_workflow_graph=".TRUE." build_workflow_graph_start="4h" build_workflow_graph_end="24h"  />        
@@ -83,4 +83,5 @@
             <variable id="using_server2" type="bool">true</variable>
             <variable id="ratio_server2" type="int">50</variable>
+            <variable id="number_pools_server2" type="int">1</variable>
          </variable_group>
 
Index: XIOS/dev/dev_trunk_omp/inputs/vis2.html
===================================================================
--- XIOS/dev/dev_trunk_omp/inputs/vis2.html	(revision 1689)
+++ XIOS/dev/dev_trunk_omp/inputs/vis2.html	(revision 1691)
@@ -70,4 +70,5 @@
 
     <script type="text/javascript">
+
         //######################################################################################################
         $(document).ready(function() {
@@ -88,4 +89,53 @@
                 if (node.class == 5) //temporal filter
                 {
+                    // disable all parents
+                    node.hidden = true;
+                    console.log("node.id = ", node.id, "hidden = ", node.hidden);
+                    nodes.update(node);
+
+                    var connectedEdgeArray = edges.get(network.getConnectedEdges(node.id));
+                    for (j = 0; j < connectedEdgeArray.length; j++) {
+                        var edge = connectedEdgeArray[j];
+                        if (edge.to == node.id) {
+                            edge.hidden = true;
+                        }
+
+                    }
+                    edges.update(connectedEdgeArray);
+
+                    var allNode = nodes.get(allParentsNode);
+                    for (i = 0; i < allNode.length; i++) {
+                        var node = allNode[i];
+                        node.hidden = true;
+                    }
+                    nodes.update(allNode);
+
+                    for (i = 0; i < allNode.length; i++) {
+                        var node = allNode[i];
+
+                        var cNodes = nodes.get(network.getConnectedNodes(node.id, 'to'));
+                        for (j = 0; j < cNodes.length; j++) {
+                            var cnode = cNodes[j];
+
+                            if (cnode.hidden != true) {
+                                node.hidden = false;
+                                nodes.update(node);
+                                break;
+                            }
+                        }
+                    }
+                    nodes.update(allNode);
+
+                    node = nodes.get(nodeSelected);
+                    node.hidden = false;
+                    console.log("node.id = ", node.id, "hidden = ", node.hidden);
+                    nodes.update(node);
+
+                    allNode = nodes.get();
+                    nodes.update(allNode);
+
+
+
+                    // enable last input
                     var inputnodes = network.getConnectedNodes(node.id, 'from');
                     var repere = 0;
@@ -578,17 +628,4 @@
                 }
                 nodes.update(connectedChild);
-            });
-
-
-
-            //===========================================================
-            $('#enableAllChild').on('click', function() {
-                console.log("enableAllChild: ", allChildNode);
-
-                var node = nodes.get(nodeSelected);
-                node.hidden = false;
-                console.log("node.id = ", node.id, "hidden = ", node.hidden);
-                nodes.update(node);
-
                 var connectedEdgeArray = edges.get(network.getConnectedEdges(node.id));
                 for (j = 0; j < connectedEdgeArray.length; j++) {
@@ -600,4 +637,30 @@
                 }
                 edges.update(connectedEdgeArray);
+
+            });
+
+
+
+            //===========================================================
+            $('#enableAllChild').on('click', function() {
+                console.log("enableAllChild: ", allChildNode);
+
+                var node = nodes.get(nodeSelected);
+                node.hidden = false;
+                console.log("node.id = ", node.id, "hidden = ", node.hidden);
+                nodes.update(node);
+
+                var connectedEdgeArray = edges.get(network.getConnectedEdges(node.id));
+                for (j = 0; j < connectedEdgeArray.length; j++) {
+                    var edge = connectedEdgeArray[j];
+                    if (edge.from == node.id) {
+                        edge.hidden = false;
+                    }
+
+                }
+                edges.update(connectedEdgeArray);
+
+                var edgesforupdate = [];
+                var count=0;
 
 
@@ -630,10 +693,22 @@
                         }
                     }
-                }
-
-                nodes.update(allNode);
+                    var decendentEdges = edges.get(network.getConnectedEdges(node.id)); 
+                    for (j = 0; j < decendentEdges.length; j++) {
+                        if (decendentEdges[j].from == node.id) {
+                            edgesforupdate[count] = decendentEdges[j];
+
+                            edgesforupdate[count].hidden = false;
+                            count++;
+                        }
+                    }
+                }
+
+                nodes.update(allNode);
+                edges.update(edgesforupdate);
 
                 allNode = nodes.get();
                 nodes.update(allNode);
+
+                
 
             });
@@ -657,4 +732,7 @@
                 edges.update(connectedEdgeArray);
 
+                var edgesforupdate = [];
+                var count=0;
+
                 var allNode = nodes.get(allChildNode);
                 for (i = 0; i < allNode.length; i++) {
@@ -670,5 +748,4 @@
                     for (j = 0; j < pNodes.length; j++) {
                         var pnode = pNodes[j];
-                        // console.log("node.id = ", node.id, "node.hidden = ", node.hidden, "pnode.id=", pnode.id, "pnode.hidden = ", pnode.hidden);
 
                         if (pnode.hidden != true) {
@@ -678,7 +755,16 @@
                         }
                     }
-                    // console.log("node.id = ", node.id, "node.hidden = ", node.hidden);
-                }
-                nodes.update(allNode);
+                    var decendentEdges = edges.get(network.getConnectedEdges(node.id)); 
+                    for (j = 0; j < decendentEdges.length; j++) {
+                        if (decendentEdges[j].from == node.id) {
+                            edgesforupdate[count] = decendentEdges[j];
+
+                            edgesforupdate[count].hidden = true;
+                            count++;
+                        }
+                    }
+                }
+                nodes.update(allNode);
+                edges.update(edgesforupdate);
 
                 node = nodes.get(nodeSelected);
@@ -897,5 +983,5 @@
                                         enabled: true,
                                         direction: "LR",
-                                        sortMethod: "direct",
+                                        sortMethod: "directed",
                                         levelSeparation: 300,
                                         nodeSpacing: 80,
@@ -1065,5 +1151,5 @@
 
             <button type="button" class="btn btn-success" id="lastTemporal">Enable last temporal input</button>
-            <button type="button" class="btn btn-success" id="showGraph">Show subgraph (and hide other)</button>
+            <button type="button" class="btn btn-success" id="showGraph">Show subgraph (and hide other)</button>            
 
 